Draft Draft2Sketch
|
Menu location |
---|
Modification → Draft to sketch Modify → Draft to sketch |
Workbenches |
Draft, BIM |
Default shortcut |
None |
Introduced in version |
- |
See also |
None |
Description
The Draft Draft2Sketch command converts Draft objects to Sketcher Sketches and vice versa.
Converting Draft objects to Sketcher Sketches
Usage
- Optionally select one or more Draft objects or Sketcher Sketches.
- There are several ways to invoke the command:
- Press the
Draft to sketch button.
- Draft: Select the Modification →
Draft to sketch option from the menu.
- BIM: Select the Modify →
Draft to sketch option from the menu.
- Press the
- If you have not yet selected an object: select an object in the 3D view.
- A new object is created.
Notes
- Non-Draft objects that are totally planar can also be converted.
- The command can only handle objects made up out of straight lines, circular arcs, elliptical arcs, B-Splines and Bézier curves.
- Draft BezCurves will be approximated by Sketcher BSplines.
- The external KicadStepUp Workbench contains a command to convert a Draft BSpline into a series of Sketcher Arcs. For more information see the forum topic BSplines to Shape2DView and Sketcher.
- This other forum topic contains a macro for such a conversion.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To convert objects to a sketch use the make_sketch
method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeSketch
method.
sketch = make_sketch(objects_list, autoconstraints=False, addTo=None, delete=False, name="Sketch", radiusPrecision=-1, tol=1e-3)
objects_list
contains the objects to be converted. It is either a single object or a list of objects.Draft
objects,Part::Feature
objects andPart.Shape
objects are supported.- If
autoconstraints
isTrue
coincident constraints are added to nodes belonging to the same source object. addTo
is the existing sketch object the geometry is added to. If not supplied a new sketch is created.- If
delete
isTrue
the source objects are deleted. name
is the name for the new sketch.radiusPrecision
indicates how radius constraints should be handled:- Use
-1
to disable radius constraints. - Use
0
to add individual radius constraints. - Use a positive number to round radii according to this precision, and to add equal constraints between curves with equal radii.
- Use
tol
is the tolerance used to check if shapes are planar and co-planar. Use-1
for a strict analysis.sketch
is returned with the sketch object.
To convert a sketch to Draft objects use the draftify
method of the Draft module.
draftify(objectslist, makeblock=False, delete=True)
objectslist
contains the objects to be converted. It is either a single object or a list of objects.- If
makeblock
isTrue
the converted objects are grouped in aPart::Part2DObject
. - If
delete
isTrue
the source objects are deleted.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
rectangle = Draft.make_rectangle(2000, 1000)
circle = Draft.make_circle(500)
doc.recompute()
sketch_from_draft = Draft.make_sketch([rectangle, circle], autoconstraints=True, delete=False, radiusPrecision=0)
doc.recompute()
draft_from_sketch = Draft.draftify(sketch_from_draft, delete=False)
doc.recompute()
- Drafting: Line, Polyline, Fillet, Arc, Arc by 3 points, Circle, Ellipse, Rectangle, Polygon, B-spline, Cubic Bézier curve, Bézier curve, Point, Facebinder, ShapeString, Hatch
- Annotation: Text, Dimension, Label, Annotation styles, Annotation scale
- Modification: Move, Rotate, Scale, Mirror, Offset, Trimex, Stretch, Clone, Array, Polar array, Circular array, Path array, Path link array, Point array, Point link array, Edit, Subelement highlight, Join, Split, Upgrade, Downgrade, Wire to B-spline, Draft to sketch, Set slope, Flip dimension, Shape 2D view
- Draft Tray: Select plane, Set style, Toggle construction mode, AutoGroup
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid
- Miscellaneous: Apply current style, Layer, Manage layers, Add a new named group, Move to group, Select group, Add to construction group, Toggle normal/wireframe display, Create working plane proxy, Heal, Show snap toolbar
- Additional: Constraining, Pattern, Preferences, Import Export Preferences, DXF/DWG, SVG, OCA, DAT
- Context menu:
- Layer container: Merge layer duplicates, Add new layer
- Layer: Activate this layer, Select layer contents
- Text: Open hyperlinks
- Wire: Flatten
- Working plane proxy: Write camera position, Write objects state

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub